using System;
using System.Collections.Generic;
using System.Text;

namespace SnakeGame
{
    class Program
    {
        struct SnakeBodySegment
        {
            public int X;
            public int Y;
        }

        static void Main(string[] args)
        {
            int xSpeed = 1;
            int ySpeed = 0;

            int growCount = 0;
            int growLimit = 5;

            bool gameRunning = true;

            SnakeBodySegment[] snake = new SnakeBodySegment[25*80];
            int snakeLength = 1;

            Console.Clear();

            while (gameRunning)
            {
                #region Erase the old snake

                for (int i = 0; i < snakeLength; i = i + 1)
                {
                    Console.SetCursorPosition(snake[i].X, snake[i].Y);
                    Console.Write(" ");
                }

                #endregion

                #region Update the game state

                #region Handle player input

                if (Console.KeyAvailable)
                {
                    ConsoleKeyInfo keyInfo = Console.ReadKey(true);

                    switch (keyInfo.Key)
                    {
                        case ConsoleKey.UpArrow:
                            ySpeed = -1;
                            xSpeed = 0;
                            break;
                        case ConsoleKey.DownArrow:
                            ySpeed = 1;
                            xSpeed = 0;
                            break;
                        case ConsoleKey.LeftArrow:
                            ySpeed = 0;
                            xSpeed = -1;
                            break;
                        case ConsoleKey.RightArrow:
                            ySpeed = 0;
                            xSpeed = 1;
                            break;
                    }
                }

                #endregion 

                #region Update game engine

                growCount = growCount + 1;

                if (growCount >= growLimit)
                {
                    growCount = 0;
                    snakeLength = snakeLength + 1;
                }

                for ( int i = snakeLength ; i > 0  ; i = i - 1) 
                {
                    snake[i] = snake[i-1];
                }

                snake[0].X = snake[0].X + xSpeed;
                snake[0].Y = snake[0].Y + ySpeed;

                /// check for snake colliding with itself

                for (int i = 1; i < snakeLength; i = i + 1)
                {
                    if (snake[0].X == snake[i].X && snake[0].Y == snake[i].Y)
                    {
                        gameRunning = false;
                        break;
                    }
                }

                /// check for going off the screen
                /// 
                if (snake[0].X < 0 || snake[0].X >= Console.WindowWidth ||
                    snake[0].Y < 0 || snake[0].Y >= Console.WindowHeight)
                {
                    gameRunning = false;
                    break;
                }
                    
                #endregion

                #endregion 

                #region Draw the new snake

                for (int i = 0; i < snakeLength; i = i + 1)
                {
                    Console.SetCursorPosition(snake[i].X, snake[i].Y);
                    Console.Write("*");
                }

                #endregion 

                System.Threading.Thread.Sleep(100);
            }

            Console.Clear();
            Console.WriteLine("Game Over");
        }
    }
}
